import femto.mode.HiRes16Color;
import femto.Game;
import femto.State;
import femto.input.Button;
import femto.palette.Psygnosia;
import femto.font.Font5x7;
import femto.Cookie;

class Bookmark extends femto.Cookie {
    Bookmark(){
        begin("fltlnd");
    }
    int pos;
}

class Main extends State {
    
    static Bookmark mark;

    HiRes16Color screen; // the screenmode we want to draw with

    public static pointer word(int i){
        pointer p;
        __inline_cpp__("
        #include \"texts/words.h\"
        const char *c = words;
        while(i--){
            while(*c++);
        }
        p = c;
        ");
        return p;
    }
    
    static int pos = 0;
    public static int nextIndex(){
        int ret;
        __inline_cpp__("
        #include \"texts/indices.h\"
        if( pos >= sizeof(indices) ) 
            pos = 0;
        char c = indices[pos++];
        ret = c & 0x7F;
        int s = 7;
        while( c & 0x80 ){
            c = indices[pos++];
            ret |= (c & 0x7F) << s;
            s += 7;
        }
        ");
        return ret;
    }

    // start the game using Main as the initial state
    // and TIC80 as the menu's font
    public static void main(String[] args){
        Game.run( Font5x7.font(), new Main() );
    }
    
    // Avoid allocation in a State's constructor.
    // Allocate on init instead.
    void init(){
        mark = new Bookmark();
        pos = mark.pos;
        screen = new HiRes16Color(Psygnosia.palette(), Font5x7.font());
        screen.setTextPosition( 1, 0 );
        screen.textColor = 9;
        screen.clear(0);
        screen.lineSpacing = 2;
        screen.textLeftLimit = 2;
        screen.textRightLimit = 220 - 4;
    }
    
    // update is called by femto.Game every frame
    int px, py;
    void update(){
        pointer w = word(nextIndex());
        char b = (char) System.memory.LDRB(w);
        if(b == '.' || b == '?' || b == '!' || b == ',' || b == ':'){
            screen.setTextPosition(px, py);
        }

        if(screen.textWidth(w) + screen.textX >= screen.textRightLimit){
            screen.print((pointer)"\n");
        }

        if( screen.textY > 155 ){
            screen.flush();
            Thread.sleep(100);
            screen.setTextPosition( 1, 0 );
            screen.clear(0);
            while(true){
                if(Button.A.isPressed()){
                    while(Button.A.isPressed());
                    mark.pos = pos - 1;
                    break;
                }
                
                if(pos != 0 && Button.Up.isPressed()){
                    while(Button.Up.isPressed());
                    pos = 0;
                    return;
                }
                
                if(Button.Down.isPressed()){
                    while(Button.Down.isPressed());
                    pos = mark.pos;
                    return;
                }
                
                if(Button.B.isPressed()){
                    while(Button.B.isPressed());

                    mark.saveCookie();
                    
                    screen.setTextPosition( 10, 50 );
                    screen.print((pointer)"Bookmark Saved");
                    screen.flush();
                    Thread.sleep(1000);
                    screen.setTextPosition( 1, 0 );
                    screen.clear(0);
                    return;
                }
            }
        }

        screen.print(w);
        px = (int) screen.textX; 
        py = (int) screen.textY;
        if(b != '\n')
            screen.print((pointer)" ");
    }
    
}
